Loading...
Searching...
No Matches
itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform > Class Template Reference

`#include <itkGPUAdvancedCombinationTransform.h>`

## Detailed Description

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>
class itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >

GPU version of AdvancedCombinationTransform.

Author
  Denis P. Shamonin and Marius Staring. Division of Image Processing, Department of Radiology, Leiden, The Netherlands

Note
  This work was funded by the Netherlands Organisation for Scientific Research (NWO NRG-2010.02 and NWO 639.021.124).

Definition at line 40 of file itkGPUAdvancedCombinationTransform.h.

Inheritance diagram for itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | CPUSuperclass = TParentTransform
using | GPUSuperclass = GPUCompositeTransformBase<TScalarType, NDimensions>
using | GPUTransformType = typename GPUSuperclass::TransformType
using | Pointer = SmartPointer<Self>
using | Self = GPUAdvancedCombinationTransform
using | TransformTypeConstPointer = typename GPUSuperclass::TransformTypeConstPointer
using | TransformTypePointer = typename GPUSuperclass::TransformTypePointer
Public Types inherited from itk::AdvancedCombinationTransform< TScalarType, NDimensions >
using | ConstPointer = SmartPointer<const Self>
using | CurrentTransformConstPointer = typename CurrentTransformType::ConstPointer
using | CurrentTransformInverseTransformBasePointer = typename CurrentTransformType::InverseTransformBasePointer
using | CurrentTransformInverseTransformBaseType = typename CurrentTransformType::InverseTransformBaseType
using | CurrentTransformPointer = typename CurrentTransformType::Pointer
using | CurrentTransformType = Superclass
using | InitialTransformConstPointer = typename InitialTransformType::ConstPointer
using | InitialTransformInverseTransformBasePointer = typename InitialTransformType::InverseTransformBasePointer
using | InitialTransformInverseTransformBaseType = typename InitialTransformType::InverseTransformBaseType
using | InitialTransformPointer = typename InitialTransformType::Pointer
using | InitialTransformType = Superclass
using | InternalMatrixType
using | InverseTransformBaseType = typename Superclass::InverseTransformBaseType
using | JacobianOfSpatialHessianType
using | JacobianOfSpatialJacobianType
using | MovingImageGradientType
using | MovingImageGradientValueType
using | NonZeroJacobianIndicesType
using | Pointer = SmartPointer<Self>
using | Self = AdvancedCombinationTransform
using | SpatialHessianType
using | SpatialJacobianType
using | Superclass = AdvancedTransform<TScalarType, NDimensions, NDimensions>
using | TransformType = typename Superclass::TransformType
using | TransformTypeConstPointer = typename TransformType::ConstPointer
using | TransformTypePointer = typename TransformType::Pointer
Public Types inherited from itk::AdvancedTransform< TScalarType, 3, 3 >
using | ConstPointer
using | InternalMatrixType
using | InverseTransformBaseType
using | JacobianOfSpatialHessianType
using | JacobianOfSpatialJacobianType
using | MovingImageGradientType
using | MovingImageGradientValueType
using | NonZeroJacobianIndicesType
using | Pointer
using | Self
using | SpatialHessianType
using | SpatialJacobianType
using | Superclass
using | TransformType
using | TransformTypeConstPointer
using | TransformTypePointer
Public Types inherited from itk::GPUCompositeTransformBase< float, 3 >
using | GPUSuperclass
using | ScalarType
using | Self
using | TransformType
using | TransformTypeConstPointer
using | TransformTypePointer
Public Types inherited from itk::GPUTransformBase
using | Self = GPUTransformBase

## Public Member Functions

virtual const char * | GetClassName () const
const TransformTypePointer | GetNthTransform (SizeValueType n) const override
SizeValueType | GetNumberOfTransforms () const override
Public Member Functions inherited from itk::AdvancedCombinationTransform< TScalarType, NDimensions >
void | EvaluateJacobianWithImageGradientProduct (const InputPointType &inputPoint, const MovingImageGradientType &movingImageGradient, DerivativeType &imageJacobian, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const override
const FixedParametersType & | GetFixedParameters () const override
bool | GetHasNonZeroSpatialHessian () const override
bool | GetInverse (Self *inverse) const
void | GetJacobian (const InputPointType &inputPoint, JacobianType &j, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const override
void | GetJacobianOfSpatialHessian (const InputPointType &inputPoint, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const override
void | GetJacobianOfSpatialHessian (const InputPointType &inputPoint, SpatialHessianType &sh, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const override
void | GetJacobianOfSpatialJacobian (const InputPointType &inputPoint, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const override
void | GetJacobianOfSpatialJacobian (const InputPointType &inputPoint, SpatialJacobianType &sj, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const override
const TransformTypePointer | GetNthTransform (SizeValueType n) const
NumberOfParametersType | GetNumberOfNonZeroJacobianIndices () const override
NumberOfParametersType | GetNumberOfParameters () const override
SizeValueType | GetNumberOfTransforms () const
const ParametersType & | GetParameters () const override
void | GetSpatialHessian (const InputPointType &inputPoint, SpatialHessianType &sh) const override
void | GetSpatialJacobian (const InputPointType &inputPoint, SpatialJacobianType &sj) const override
TransformCategoryEnum | GetTransformCategory () const override
virtual bool | GetUseAddition () const
virtual bool | GetUseComposition () const
bool | HasNonZeroJacobianOfSpatialHessian () const
bool | IsLinear () const override
| ITK_DISALLOW_COPY_AND_MOVE (AdvancedCombinationTransform)
| itkGetModifiableObjectMacro (CurrentTransform, CurrentTransformType)
| itkGetModifiableObjectMacro (InitialTransform, InitialTransformType)
| itkStaticConstMacro (SpaceDimension, unsigned int, NDimensions)
void | SetCurrentTransform (CurrentTransformType *_arg)
void | SetFixedParameters (const FixedParametersType &fixedParam) override
void | SetInitialTransform (InitialTransformType *_arg)
void | SetParameters (const ParametersType &param) override
void | SetParametersByValue (const ParametersType &param) override
void | SetUseAddition (bool _arg)
void | SetUseComposition (bool _arg)
OutputCovariantVectorType | TransformCovariantVector (const InputCovariantVectorType &) const override
OutputPointType | TransformPoint (const InputPointType &point) const override
OutputVectorType | TransformVector (const InputVectorType &) const override
OutputVnlVectorType | TransformVector (const InputVnlVectorType &) const override
Public Member Functions inherited from itk::AdvancedTransform< TScalarType, 3, 3 >
void | ComputeJacobianWithRespectToParameters (const InputPointType &, JacobianType &) const override
virtual bool | GetHasNonZeroJacobianOfSpatialHessian () const
| ITK_DISALLOW_COPY_AND_MOVE (AdvancedTransform)
| itkStaticConstMacro (InputSpaceDimension, unsigned int, NInputDimensions)
Public Member Functions inherited from itk::GPUCompositeTransformBase< float, 3 >
virtual bool | HasBSplineTransform () const
virtual bool | HasIdentityTransform () const
virtual bool | HasMatrixOffsetTransform () const
virtual bool | HasTranslationTransform () const
virtual bool | IsBSplineTransform (const std::vcl_size_t index) const
virtual bool | IsIdentityTransform (const std::vcl_size_t index) const
virtual bool | IsMatrixOffsetTransform (const std::vcl_size_t index) const
virtual bool | IsTranslationTransform (const std::vcl_size_t index) const
| itkStaticConstMacro (InputSpaceDimension, unsigned int, NDimensions)
Public Member Functions inherited from itk::GPUTransformBase
virtual const char * | GetNameOfClass () const
virtual GPUDataManager::Pointer | GetParametersDataManager () const
virtual bool | IsBSplineTransform () const
virtual bool | IsIdentityTransform () const
virtual bool | IsMatrixOffsetTransform () const
virtual bool | IsTranslationTransform () const

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::AdvancedCombinationTransform< TScalarType, NDimensions >
static Pointer | New ()

## Protected Member Functions

| GPUAdvancedCombinationTransform ()=default
void | PrintSelf (std::ostream &s, Indent indent) const override
| ~GPUAdvancedCombinationTransform () override=default
Protected Member Functions inherited from itk::AdvancedCombinationTransform< TScalarType, NDimensions >
| AdvancedCombinationTransform ()
void | EvaluateJacobianWithImageGradientProductNoCurrentTransform (const InputPointType &, const MovingImageGradientType &, DerivativeType &, NonZeroJacobianIndicesType &) const
void | EvaluateJacobianWithImageGradientProductNoInitialTransform (const InputPointType &, const MovingImageGradientType &, DerivativeType &, NonZeroJacobianIndicesType &) const
void | EvaluateJacobianWithImageGradientProductUseAddition (const InputPointType &, const MovingImageGradientType &, DerivativeType &, NonZeroJacobianIndicesType &) const
void | EvaluateJacobianWithImageGradientProductUseComposition (const InputPointType &, const MovingImageGradientType &, DerivativeType &, NonZeroJacobianIndicesType &) const
void | GetJacobianNoCurrentTransform (const InputPointType &, JacobianType &, NonZeroJacobianIndicesType &) const
void | GetJacobianNoInitialTransform (const InputPointType &, JacobianType &, NonZeroJacobianIndicesType &) const
void | GetJacobianOfSpatialHessianNoCurrentTransform (const InputPointType &inputPoint, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialHessianNoCurrentTransform (const InputPointType &inputPoint, SpatialHessianType &sh, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialHessianNoInitialTransform (const InputPointType &inputPoint, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialHessianNoInitialTransform (const InputPointType &inputPoint, SpatialHessianType &sh, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialHessianUseAddition (const InputPointType &inputPoint, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialHessianUseAddition (const InputPointType &inputPoint, SpatialHessianType &sh, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialHessianUseComposition (const InputPointType &inputPoint, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialHessianUseComposition (const InputPointType &inputPoint, SpatialHessianType &sh, JacobianOfSpatialHessianType &jsh, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialJacobianNoCurrentTransform (const InputPointType &inputPoint, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialJacobianNoCurrentTransform (const InputPointType &inputPoint, SpatialJacobianType &sj, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialJacobianNoInitialTransform (const InputPointType &inputPoint, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialJacobianNoInitialTransform (const InputPointType &inputPoint, SpatialJacobianType &sj, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialJacobianUseAddition (const InputPointType &inputPoint, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialJacobianUseAddition (const InputPointType &inputPoint, SpatialJacobianType &sj, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialJacobianUseComposition (const InputPointType &inputPoint, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianOfSpatialJacobianUseComposition (const InputPointType &inputPoint, SpatialJacobianType &sj, JacobianOfSpatialJacobianType &jsj, NonZeroJacobianIndicesType &nonZeroJacobianIndices) const
void | GetJacobianUseAddition (const InputPointType &, JacobianType &, NonZeroJacobianIndicesType &) const
void | GetJacobianUseComposition (const InputPointType &, JacobianType &, NonZeroJacobianIndicesType &) const
void | GetSpatialHessianNoCurrentTransform (const InputPointType &inputPoint, SpatialHessianType &sh) const
void | GetSpatialHessianNoInitialTransform (const InputPointType &inputPoint, SpatialHessianType &sh) const
void | GetSpatialHessianUseAddition (const InputPointType &inputPoint, SpatialHessianType &sh) const
void | GetSpatialHessianUseComposition (const InputPointType &inputPoint, SpatialHessianType &sh) const
void | GetSpatialJacobianNoCurrentTransform (const InputPointType &inputPoint, SpatialJacobianType &sj) const
void | GetSpatialJacobianNoInitialTransform (const InputPointType &inputPoint, SpatialJacobianType &sj) const
void | GetSpatialJacobianUseAddition (const InputPointType &inputPoint, SpatialJacobianType &sj) const
void | GetSpatialJacobianUseComposition (const InputPointType &inputPoint, SpatialJacobianType &sj) const
OutputPointType | TransformPointNoCurrentTransform (const InputPointType &point) const
OutputPointType | TransformPointNoInitialTransform (const InputPointType &point) const
OutputPointType | TransformPointUseAddition (const InputPointType &point) const
OutputPointType | TransformPointUseComposition (const InputPointType &point) const
void | UpdateCombinationMethod ()
| ~AdvancedCombinationTransform () override=default
Protected Member Functions inherited from itk::AdvancedTransform< TScalarType, 3, 3 >
| AdvancedTransform ()=default
| ~AdvancedTransform () override=default
Protected Member Functions inherited from itk::GPUCompositeTransformBase< float, 3 >
GPUDataManager::Pointer | GetParametersDataManager (const std::vcl_size_t index) const override
bool | GetSourceCode (std::string &source) const override
| GPUCompositeTransformBase ()=default
| ~GPUCompositeTransformBase () override=default
Protected Member Functions inherited from itk::GPUTransformBase
| GPUTransformBase ()
virtual | ~GPUTransformBase ()=default

## Private Member Functions

| GPUAdvancedCombinationTransform (const Self &other)=delete
const Self & | operator= (const Self &)=delete

## Additional Inherited Members

Protected Attributes inherited from itk::AdvancedTransform< TScalarType, 3, 3 >
bool | m_HasNonZeroJacobianOfSpatialHessian
bool | m_HasNonZeroSpatialHessian
Protected Attributes inherited from itk::GPUTransformBase
GPUDataManager::Pointer | m_ParametersDataManager {}

## Member Typedef Documentation

## ConstPointer

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

using itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::ConstPointer = SmartPointer<const Self>

Definition at line 50 of file itkGPUAdvancedCombinationTransform.h.

## CPUSuperclass

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

using itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::CPUSuperclass = TParentTransform

Definition at line 47 of file itkGPUAdvancedCombinationTransform.h.

## GPUSuperclass

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

using itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::GPUSuperclass = GPUCompositeTransformBase<TScalarType, NDimensions>

Definition at line 48 of file itkGPUAdvancedCombinationTransform.h.

## GPUTransformType

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

using itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::GPUTransformType = typename GPUSuperclass::TransformType

Sub transform types.

Definition at line 59 of file itkGPUAdvancedCombinationTransform.h.

## Pointer

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

using itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::Pointer = SmartPointer<Self>

Definition at line 49 of file itkGPUAdvancedCombinationTransform.h.

## Self

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

using itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::Self = GPUAdvancedCombinationTransform

Standard class typedefs.

Definition at line 46 of file itkGPUAdvancedCombinationTransform.h.

## TransformTypeConstPointer

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

using itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::TransformTypeConstPointer = typename GPUSuperclass::TransformTypeConstPointer

Definition at line 61 of file itkGPUAdvancedCombinationTransform.h.

## TransformTypePointer

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

using itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::TransformTypePointer = typename GPUSuperclass::TransformTypePointer

Definition at line 60 of file itkGPUAdvancedCombinationTransform.h.

## Constructor & Destructor Documentation

## GPUAdvancedCombinationTransform() [1/2]

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::GPUAdvancedCombinationTransform | ( |  | ) |

protected default

## ~GPUAdvancedCombinationTransform()

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::~GPUAdvancedCombinationTransform | ( |  | ) |

override protected default

## GPUAdvancedCombinationTransform() [2/2]

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::GPUAdvancedCombinationTransform | ( | const Self & | other | ) |

private delete

## Member Function Documentation

## GetClassName()

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

virtual const char * itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::AdvancedCombinationTransform< TScalarType, NDimensions >.

## GetNthTransform()

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

const TransformTypePointer itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::GetNthTransform | ( | SizeValueType | n | ) | const

inline override virtual

Get the Nth transform.

Implements itk::GPUCompositeTransformBase< float, 3 >.

Definition at line 72 of file itkGPUAdvancedCombinationTransform.h.

## GetNumberOfTransforms()

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

SizeValueType itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::GetNumberOfTransforms | ( |  | ) | const

inline override virtual

Get number of transforms in composite transform.

Implements itk::GPUCompositeTransformBase< float, 3 >.

Definition at line 65 of file itkGPUAdvancedCombinationTransform.h.

## New()

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

Pointer itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::New | ( |  | ) |

static

Method for creation through the object factory.

## operator=()

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

const Self & itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::operator= | ( | const Self & |  | ) |

private delete

## PrintSelf()

template<typename TScalarType = float, unsigned int NDimensions = 3, typename TParentTransform = AdvancedCombinationTransform<TScalarType, NDimensions>>

void itk::GPUAdvancedCombinationTransform< TScalarType, NDimensions, TParentTransform >::PrintSelf | ( | std::ostream & | s,
|  | Indent | indent ) const

inline override protected

Definition at line 81 of file itkGPUAdvancedCombinationTransform.h.

Generated on 1768596610 for elastix by 1.15.0 |